#include <stdio.h>
#include <pwd.h>
#include "queue.h"

extern char	*Sitefile;
extern int	numhdrs;	/* From server proper... */
extern int	numcols;	/**/
extern char	*title;		/**/
extern char	source[];	/**/
extern long	linecount;	/**/
extern time_t	timenow;	/**/

extern char	*index();
extern struct passwd *getpwuid();

#define	FF	014
#define	MAXHDR	44L	/* An asthetic value, maximum number of lines to
			 * print of a header file.  It is essentially
			 * # lines on a page - banner space - data space.
			 *    Note: this value is a long.
			 */

/*
 *		P R H E A D E R  ( )
 *  Open and print the specified header file and then force
 *  a new page.  Other interesting information is also printed.
 */
prheader (hdfile, rp)
register char *hdfile;
register struct request *rp;
{
	static	hdrdone = 0;
	struct	passwd *pw;
	char	sitename[LINESIZ];
	char	name[LINESIZ];
	char	*cp;
	int	lncount;
	register FILE	*hf;

	pw = getpwuid (rp->r_uid);

	strcpy (name, source);
	if (cp = index(name, '@'))
		*cp = 0;

	if(( hf = fopen( Sitefile, "r" )) == NULL  ||
	    fgets( sitename, LINESIZ, hf ) == NULL )
		sprintf( sitename, "Unknown Site [can't open %s]\n", Sitefile);
	if( hf )
		fclose( hf );

	hf = fopen (hdfile, "r");

	lncount = numhdrs;
	while (lncount--) {
		fputs("\n\n", stdout);
		banner (stdout, name, numcols);

		if( hf == NULL ) {
			fputs( "\n\n", stdout );
			banner( stdout, "Header-Error", numcols);
			printf ("\n\nCould not open header %s\n", hdfile);
		} else {
			if( ! hdrdone )
				copyn (hf, MAXHDR);
			else
				linecount += copyn( hf, rp->r_size - linecount );
			rewind( hf );
		}

		/*
		 *  Now print out the useful information.
		 *  Currently:
		 *	Where, who, when submitted, when printed
		 */
		printf ("\n\n		%s\n", sitename);
		printf ("	%-20s%s\n", "Requested By:", source );
		printf ("	%-20s%s  (%s)\n", "Submitted By:",
		        pw->pw_gecos, pw->pw_name);
		printf ("	%-20s%s", "Submission Date:", ctime(&rp->r_tsubmit));
		if (rp->r_tstart != 0L)
			printf("	%-20s%s", "Start Time:", ctime(&rp->r_tstart));
		printf ("	%-20s%s", "Printed:", ctime (&timenow));
		if (title)
			printf ("	%-20s%s\n", "Source File:", title);
		printf ("	%-20s%s\n", "Request ID:", rp->r_name);

		putchar (FF);
	}

	if( hf )
		fclose( hf );

	if( ! hdrdone )
		/* 1st header doesn't cost you */
		hdrdone++;

	return;
}
