/*
 *	pcopyn - transcribe arbitrary input file to stdout (for MDQS)
 *
 *	Printronix Version adapted from lpf.c.	12 Feb 83	DAW
 */

#include	<stdio.h>
#include	<sgtty.h>
#include	<signal.h>
#include	"queue.h"

#define	PRINTRONIX

#define	LINELN	132
#define	EJLINE	66
#define SKPLINE	0

int	anydone;
char	linebuf[LINELN+2];
int	ov;
int	plotmode;
char	ovbuf[LINELN];
FILE	*out = stdout;
int	npages	= 1;
int	lineno;

long
copyn( in, llimit )			/* returns # input lines done,
					   no more than llimit+PAGE-1 */
register FILE	*in;		/* input stream     */
long		llimit; 	/* input line limit */
{
	register int nskipped;

	lineno = 0;
	nskipped = 0;
	while (getline( in )) {
		if (lineno==0 && linebuf[0]==0 && nskipped<=SKPLINE+3) {
			nskipped++;
			continue;
		}
		if (lineno >= EJLINE) {
			nskipped = 0;
			putline(1);
			lineno = 0;
		} else {
			if (lineno == 0)
				while (lineno++ < SKPLINE)
					putline(-1);
			putline(0);
			lineno++;
		}
	}
	if (lineno>0)
		npages++;
	return(1);
}

getline( in )
FILE	*in;	/* the input data stream */
{
	register int col, maxcol, c;

	ov = 0;
	plotmode = 0;
	for (col=0; col<LINELN; col++) {
		linebuf[col] = ' ';
		ovbuf[col] = 0;
	}
	col = 0;
	maxcol = 0;
	for (;;) switch (c = getc(in)) {

	case EOF:
		return(0);

	default:
		if (c>=' ') {
			if (col < LINELN) {
				if (linebuf[col]=='_') {
					ov++;
					ovbuf[col] = '_';
				}
				linebuf[col++] = c;
				if (col > maxcol)
					maxcol = col;
			}
		}
		continue;

#ifdef	PRINTRONIX
	case '\05':
		plotmode = 1;
		lineno = 1;	/* to prevent SKPLINE, EJLINE */
		continue;
#endif

	case '\f':
		lineno = EJLINE;
#ifdef	PRINTRONIX
		if ( maxcol >= LINELN )
			maxcol = LINELN;
		linebuf[ maxcol ] = 0;
		return ( 1 );
#else
		continue;
#endif

	case ' ':
		col++;
		continue;

	case '\t':
		col = (col|07) + 1;
		if (col>maxcol)
			maxcol = col;
		continue;

	case '\r':
		col = 0;
		continue;

	case '_':
		if (col>=LINELN) {
			col++;
			continue;
		}
		if (linebuf[col]!=' ') {
			ovbuf[col] = '_';
			ov++;
		} else
			linebuf[col] = c;
		col++;
		if (col>maxcol)
			maxcol = col;
		continue;

	case '\n':
		if (maxcol>=LINELN)
			maxcol = LINELN;
		linebuf[maxcol] = 0;
		return(1);

	case '\b':
		if (col>0)
			col--;
		continue;
	}
}

putline(ff)
{
	register char *lp, *ep;
	register int c;
	extern errno;
	int i, j;

	errno = 0;
again:
	if (ff >= 0) {
		lp = linebuf;
#ifdef	PRINTRONIX
		if ( plotmode )
			output( '\05', out );
#endif
		while (c = *lp++)
			output(c,out);
	}
#ifdef	PRINTRONIX
	if ( ov )
	{
		output( '\r', out );
		/* to avoid printing trailing blanks */
		for ( ep= &ovbuf[LINELN-1]; *ep == 0; ep-- )
			continue;
		/* print blanks except where ovbuf is non-zero */
		for ( lp=ovbuf; lp <= ep; lp++ )
			output( *lp ? *lp : ' ', out );
	}
#endif

	if (ff > 0) {
		putc('\014', out);
		putc('\r', out);
		npages++;
	} else
		putc('\n', out);
	if (ferror(out)) {
		printf("Printer IO error\n");
		exit(1);
	}
}

output(c,fp)
register	char	c;
register	FILE	*fp;
{

	if (c == -1)
		return;
	c &= 0177;
	if (c == 0177 && !plotmode )
		putc('^',fp), c = '?';
	if (c == 033)
		c = '$';
	if (c < ' ') switch (c) {

	case '\n':
		break;

	case '\f':
	case '\b':
	case '\t':
	case '\r':
#ifdef	PRINTRONIX
	case '\05':
#endif
		break;

	default:
		putc('^',fp);
			c |= 0100;
	}
	putc(c,fp);
}
